#include <iostream>
using namespace std;

long long a[1000010], b[1000010];
long long stepen[1000010];
int main()
{
    long long n, m;
    cin >> n >> m;
    for(int i=1; i<=m; i++)
        cin >> b[i];
    for(int i=1; i<=n; i++)
        a[i]=i;
    
    for(int i=0; i<=n-m; i++)
    {
        for(int j=1; j<=m; j++)
        {
            a[i+b[j]]=a[i+j];
        }
    }
    long long c;
    cin >> c;
    stepen[0]=1;
    for(int i=1; i<=n; i++)
    {
        stepen[i]=(stepen[i-1]*c)%998244353;
    }
    long long s=0;
    for(int i=1; i<=n; i++)
      s=(s+stepen[i]*a[i])%998244353;
    cout << s<<endl;
    return 0;
}